Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.gui
Class QPen

    java.lang.Object
      com.trolltech.qt.internal.QSignalEmitterInternal
          com.trolltech.qt.QSignalEmitter
              com.trolltech.qt.QtJambiObject
                  com.trolltech.qt.gui.QPen

All Implemented Interfaces:
  QtJambiInterface, java.lang.Cloneable

    public class QPen

extends QtJambiObject
implements java.lang.Cloneable

The `QPen` class defines how a `QPainter` should draw lines and outlines of shapes. A pen has a `style()`, `width()`, `brush()`, `capStyle()` and `joinStyle()`.

The pen style defines the line type. The brush is used to fill strokes generated with the pen. Use the `QBrush` class to specify fill styles. The cap style determines the line end caps that can be drawn using `QPainter`, while the join style describes how joins between two lines are drawn. The pen width can be specified in both integer (`width()`) and floating point (`widthF()`) precision. A line width of zero indicates a cosmetic pen. This means that the pen width is always drawn one pixel wide, independent of the `transformation` set on the painter.

The various settings can easily be modified using the corresponding `setStyle()`, `setWidth()`, `setBrush()`, `setCapStyle()` and `setJoinStyle()` functions (note that the painter's pen must be reset when altering the pen's properties).

For example:

            QPainter painter = new QPainter(this);
            QPen pen = new QPen(QColor.green, 3, Qt.PenStyle.DashDotLine, Qt.PenCapStyle.RoundCap, Qt.PenJoinStyle.RoundJoin);
            painter.setPen(pen);

which is equivalent to

            QPainter painter = new QPainter(this);
            QPen pen = new QPen();  // creates a default pen

            pen.setStyle(Qt.PenStyle.DashDotLine);
            pen.setWidth(3);
            pen.setBrush(new QBrush(QColor.green));
            pen.setCapStyle(Qt.PenCapStyle.RoundCap);
            pen.setJoinStyle(Qt.PenJoinStyle.RoundJoin);

            painter.setPen(pen);

The default pen is a solid black brush with 0 width, square cap style (`Qt::SquareCap` ), and bevel join style (`Qt::BevelJoin` ).

In addition `QPen` provides the `color()` and `setColor()` convenience functions to extract and set the color of the pen's brush, respectively. Pens may also be compared and streamed.

For more information about painting in general, see The Paint System documentation.

- Pen Style
- Cap Style
- Join Style

## Pen Style

Qt provides several built-in styles represented by the `Qt::PenStyle` enum:

`Qt::SolidLine` | `Qt::DashLine` | `Qt::DotLine`
`Qt::DashDotLine` | `Qt::DashDotDotLine` | `Qt::CustomDashLine`

Simply use the `setStyle()` function to convert the pen style to either of the built-in styles, except the `Qt::CustomDashLine` style which we will come back to shortly. Setting the style to `Qt::NoPen` tells the painter to not draw lines or outlines. The default pen style is `Qt::SolidLine` .

Since Qt 4.1 it is also possible to specify a custom dash pattern using the `setDashPattern()` function which implicitly converts the style of the pen to `Qt::CustomDashLine` . The pattern argument, a QVector, must be specified as an even number of qreal entries where the entries 1, 3, 5... are the dashes and 2, 4, 6... are the spaces. For example, the custom pattern shown above is created using the following code:

            QPen pen = new QPen();
            List<Double> dashes = new ArrayList<Double>();

            double space = 4;

            dashes.add(1.0);
            dashes.add(space);
            dashes.add(3.0);
            dashes.add(space);
            dashes.add(9.0);
            dashes.add(space);
            dashes.add(27.0);
            dashes.add(space);
            dashes.add(9.0);

            pen.setDashPattern(dashes);

Note that the dash pattern is specified in units of the pens width, e.g. a dash of length 5 in width 10 is 50 pixels long.

The currently set dash pattern can be retrieved using the `dashPattern()` function. Use the `isSolid()` function to determine whether the pen has a solid fill, or not.

## Cap Style

The cap style defines how the end points of lines are drawn using `QPainter`. The cap style only apply to wide lines, i.e. when the width is 1 or greater. The `Qt::PenCapStyle` enum provides the following styles:

`Qt::SquareCap` | `Qt::FlatCap` | `Qt::RoundCap`

The `Qt::SquareCap` style is a square line end that covers the end point and extends beyond it by half the line width. The `Qt::FlatCap` style is a square line end that does not cover the end point of the line. And the `Qt::RoundCap` style is a rounded line end covering the end point.

The default is `Qt::SquareCap` .

Whether or not end points are drawn when the pen width is 0 or 1 depends on the cap style. Using `Qt::SquareCap` or `Qt::RoundCap` they are drawn, using `Qt::FlatCap` they are not drawn.

## Join Style

The join style defines how joins between two connected lines can be drawn using `QPainter`. The join style only apply to wide lines, i.e. when the width is 1 or greater. The `Qt::PenJoinStyle` enum provides the following styles:

`Qt::BevelJoin` | `Qt::MiterJoin` | `Qt::RoundJoin`

The `Qt::BevelJoin` style fills the triangular notch between the two lines. The `Qt::MiterJoin` style extends the lines to meet at an angle. And the `Qt::RoundJoin` style fills a circular arc between the two lines.

The default is `Qt::BevelJoin` .

When the `Qt::MiterJoin` style is applied, it is possible to use the `setMiterLimit()` function to specify how far the miter join can extend from the join point. The `miterLimit()` is used to reduce artifacts between line joins where the lines are close to parallel.

The `miterLimit()` must be specified in units of the pens width, e.g. a miter limit of 5 in width 10 is 50 pixels long. The default miter limit is 2, i.e. twice the pen width in pixels.

| The Path Stroking Demo The Path Stroking demo shows Qt's built-in dash patterns and shows how custom patterns can be used to extend the range of available patterns.

See also:
  `QPainter`, `QBrush`, Path Stroking Demo, and Scribble Example.

Nested Class Summary

Nested classes/interfaces inherited from class com.trolltech.qt.QSignalEmitter
`QSignalEmitter.AbstractSignal, QSignalEmitter.Signal0, QSignalEmitter.Signal1, QSignalEmitter.Signal2, QSignalEmitter.Signal3, QSignalEmitter.Signal4, QSignalEmitter.Signal5, QSignalEmitter.Signal6, QSignalEmitter.Signal7, QSignalEmitter.Signal8, QSignalEmitter.Signal9`

Nested classes/interfaces inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`com.trolltech.qt.internal.QSignalEmitterInternal.AbstractSignalInternal`

Field Summary
`static QPen` | `NoPen`

Fields inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`currentSender`

Constructor Summary
`QPen()` Constructs a default black solid line pen with 0 width.
`QPen(QBrush brush, double width)` Constructs a pen with the specified `brush`, `width`, pen `style`, `cap` style and `join` style.
`QPen(QBrush brush, double width, Qt.PenStyle s)` Constructs a pen with the specified `brush`, `width`, pen `style`, `cap` style and `join` style.
`QPen(QBrush brush, double width, Qt.PenStyle s, Qt.PenCapStyle c)` Constructs a pen with the specified `brush`, `width`, pen `style`, `cap` style and `join` style.
`QPen(QBrush brush, double width, Qt.PenStyle s, Qt.PenCapStyle c, Qt.PenJoinStyle j)` Constructs a pen with the specified `brush`, `width`, pen `style`, `cap` style and `join` style.
`QPen(QColor color)` Constructs a solid line pen with 0 width and the given `color`.
`QPen(QColor color, double width)` This is an overloaded constructor provided for convenience.
`QPen(QColor color, double width, Qt.PenStyle s)` Constructs a pen with the specified `brush`, `width`, pen `style`, `cap` style and `join` style.
`QPen(QColor color, double width, Qt.PenStyle s, Qt.PenCapStyle c)` Constructs a pen with the specified `brush`, `width`, pen `style`, `cap` style and `join` style.
`QPen(QColor color, double width, Qt.PenStyle s, Qt.PenCapStyle c, Qt.PenJoinStyle j)` Constructs a pen with the specified `brush`, `width`, pen `style`, `cap` style and `join` style.
`QPen(QPen pen)` Constructs a pen that is a copy of the given `pen`.
`QPen(Qt.PenStyle arg__1)` Constructs a black pen with 0 width and the given `style`.

Method Summary
`QBrush` | `brush()` Returns the brush used to fill strokes generated with this pen.
`Qt.PenCapStyle` | `capStyle()` Returns the pen's cap style.
`QPen` | `clone()` This method is reimplemented for internal reasons
`QColor` | `color()` Returns the color of this pen's brush.
`double` | `dashOffset()` Returns the dash offset for the pen.
`java.util.List` | `dashPattern()` Returns the dash pattern of this pen.
`boolean` | `isCosmetic()` Returns true if the pen is cosmetic; otherwise returns false.
`boolean` | `isSolid()` Returns true if the pen has a solid fill, otherwise false.
`Qt.PenJoinStyle` | `joinStyle()` Returns the pen's join style.
`double` | `miterLimit()` Returns the miter limit of the pen.
`void` | `readFrom(QDataStream arg__1)` Reads a QPen
`void` | `setBrush(QBrush brush)` Sets the brush used to fill strokes generated with this pen to the given `brush`.
`void` | `setCapStyle(Qt.PenCapStyle pcs)` Sets the pen's cap style to the given `style`.
`void` | `setColor(QColor color)` Sets the color of this pen's brush to the given `color`.
`void` | `setCosmetic(boolean cosmetic)` Sets this pen to cosmetic or non-cosmetic, depending on the value of `cosmetic`.
`void` | `setDashOffset(double doffset)` Sets the dash offset for this pen to the given `offset`.
`void` | `setDashPattern(java.util.List pattern)` Sets the dash pattern for this pen to the given `pattern`.
`void` | `setJoinStyle(Qt.PenJoinStyle pcs)` Sets the pen's join style to the given `style`.
`void` | `setMiterLimit(double limit)` Sets the miter limit of this pen to the given `limit`.
`void` | `setStyle(Qt.PenStyle arg__1)` Sets the pen style to the given `style`.
`void` | `setWidth(int width)` Sets the pen width to the given `width` in pixels with integer precision.
`void` | `setWidthF(double width)` Sets the pen width to the given `width` in pixels with floating point precision.
`Qt.PenStyle` | `style()` Returns the pen style.
`java.lang.String` | `toString()` Returns a string representation of the `this QPen`.
`int` | `width()` Returns the pen width with integer precision.
`double` | `widthF()` Returns the pen width with floating point precision.
`void` | `writeTo(QDataStream arg__1)` Writes thisQPen

Methods inherited from class com.trolltech.qt.QtJambiObject
`dispose, disposed, equals, finalize, reassignNativeResources, tr, tr, tr`

Methods inherited from class com.trolltech.qt.QSignalEmitter
`blockSignals, disconnect, disconnect, signalsBlocked, signalSender, thread`

Methods inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`__qt_signalInitialization`

Methods inherited from class java.lang.Object
`getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface com.trolltech.qt.QtJambiInterface
`disableGarbageCollection, nativeId, nativePointer, reenableGarbageCollection, setJavaOwnership`

Field Detail

### NoPen

    public static final QPen NoPen

Constructor Detail

### QPen

    public QPen()

  Constructs a default black solid line pen with 0 width.

### QPen

    public QPen(Qt.PenStyle arg__1)

  Constructs a black pen with 0 width and the given `style`.

See also:
  `setStyle()`.

### QPen

    public QPen(QBrush brush,
                double width,
                Qt.PenStyle s,
                Qt.PenCapStyle c)

  Constructs a pen with the specified `brush`, `width`, pen `style`, `cap` style and `join` style.

See also:
  `setBrush()`, `setWidth()`, `setStyle()`, `setCapStyle()`, and `setJoinStyle()`.

### QPen

    public QPen(QBrush brush,
                double width,
                Qt.PenStyle s)

  Constructs a pen with the specified `brush`, `width`, pen `style`, `cap` style and `join` style.

See also:
  `setBrush()`, `setWidth()`, `setStyle()`, `setCapStyle()`, and `setJoinStyle()`.

### QPen

    public QPen(QBrush brush,
                double width)

  Constructs a pen with the specified `brush`, `width`, pen `style`, `cap` style and `join` style.

See also:
  `setBrush()`, `setWidth()`, `setStyle()`, `setCapStyle()`, and `setJoinStyle()`.

### QPen

    public QPen(QBrush brush,
                double width,
                Qt.PenStyle s,
                Qt.PenCapStyle c,
                Qt.PenJoinStyle j)

  Constructs a pen with the specified `brush`, `width`, pen `style`, `cap` style and `join` style.

See also:
  `setBrush()`, `setWidth()`, `setStyle()`, `setCapStyle()`, and `setJoinStyle()`.

### QPen

    public QPen(QColor color)

  Constructs a solid line pen with 0 width and the given `color`.

See also:
  `setBrush()`, and `setColor()`.

### QPen

    public QPen(QPen pen)

  Constructs a pen that is a copy of the given `pen`.

### QPen

    public QPen(QColor color,
                double width,
                Qt.PenStyle s,
                Qt.PenCapStyle c,
                Qt.PenJoinStyle j)

  Constructs a pen with the specified `brush`, `width`, pen `style`, `cap` style and `join` style.

See also:
  `setBrush()`, `setWidth()`, `setStyle()`, `setCapStyle()`, and `setJoinStyle()`.

### QPen

    public QPen(QColor color,
                double width,
                Qt.PenStyle s,
                Qt.PenCapStyle c)

  Constructs a pen with the specified `brush`, `width`, pen `style`, `cap` style and `join` style.

See also:
  `setBrush()`, `setWidth()`, `setStyle()`, `setCapStyle()`, and `setJoinStyle()`.

### QPen

    public QPen(QColor color,
                double width,
                Qt.PenStyle s)

  Constructs a pen with the specified `brush`, `width`, pen `style`, `cap` style and `join` style.

See also:
  `setBrush()`, `setWidth()`, `setStyle()`, `setCapStyle()`, and `setJoinStyle()`.

### QPen

    public QPen(QColor color,
                double width)

  This is an overloaded constructor provided for convenience.

Method Detail

### brush

    public final QBrush brush()

  Returns the brush used to fill strokes generated with this pen.

See also:
  `setBrush()`.

### capStyle

    public final Qt.PenCapStyle capStyle()

  Returns the pen's cap style.

See also:
  `setCapStyle()`, and `Cap Style`.

### color

    public final QColor color()

  Returns the color of this pen's brush.

See also:
  `brush()`, and `setColor()`.

### dashOffset

    public final double dashOffset()

  Returns the dash offset for the pen.

See also:
  `setDashOffset()`.

### dashPattern

    public final java.util.List dashPattern()

  Returns the dash pattern of this pen.

See also:
  `setDashPattern()`, `style()`, and `isSolid()`.

### isCosmetic

    public final boolean isCosmetic()

  Returns true if the pen is cosmetic; otherwise returns false.

  Cosmetic pens are used to draw strokes that have a constant width regardless of any transformations applied to the `QPainter` they are used with. Drawing a shape with a cosmetic pen ensures that its outline will have the same thickness at different scale factors.

  A zero width pen is cosmetic by default; pens with a non-zero width are non-cosmetic.

See also:
  `setCosmetic()`, and `widthF()`.

### isSolid

    public final boolean isSolid()

  Returns true if the pen has a solid fill, otherwise false.

See also:
  `style()`, and `dashPattern()`.

### joinStyle

    public final Qt.PenJoinStyle joinStyle()

  Returns the pen's join style.

See also:
  `setJoinStyle()`, and `Join Style`.

### miterLimit

    public final double miterLimit()

  Returns the miter limit of the pen. The miter limit is only relevant when the join style is set to `Qt::MiterJoin` .

See also:
  `setMiterLimit()`, and `Join Style`.

### writeTo

    public final void writeTo(QDataStream arg__1)

  Writes thisQPen

### readFrom

    public final void readFrom(QDataStream arg__1)

  Reads a QPen

### setBrush

    public final void setBrush(QBrush brush)

  Sets the brush used to fill strokes generated with this pen to the given `brush`.

See also:
  `brush()`, and `setColor()`.

### setCapStyle

    public final void setCapStyle(Qt.PenCapStyle pcs)

  Sets the pen's cap style to the given `style`. The default value is `Qt::SquareCap` .

See also:
  `capStyle()`, and `Cap Style`.

### setColor

    public final void setColor(QColor color)

  Sets the color of this pen's brush to the given `color`.

See also:
  `setBrush()`, and `color()`.

### setCosmetic

    public final void setCosmetic(boolean cosmetic)

  Sets this pen to cosmetic or non-cosmetic, depending on the value of `cosmetic`.

See also:
  `isCosmetic()`.

### setDashOffset

    public final void setDashOffset(double doffset)

  Sets the dash offset for this pen to the given `offset`. This implicitly converts the style of the pen to `Qt::CustomDashLine` .

See also:
  `dashOffset()`.

### setDashPattern

    public final void setDashPattern(java.util.List pattern)

  Sets the dash pattern for this pen to the given `pattern`. This implicitly converts the style of the pen to `Qt::CustomDashLine` .

  The pattern must be specified as an even number of entries where the entries 1, 3, 5... are the dashes and 2, 4, 6... are the spaces. For example:

              QPen pen = new QPen();
              List<Double> dashes = new ArrayList<Double>();

              double space = 4;

              dashes.add(1.0);
              dashes.add(space);
              dashes.add(3.0);
              dashes.add(space);
              dashes.add(9.0);
              dashes.add(space);
              dashes.add(27.0);
              dashes.add(space);
              dashes.add(9.0);

              pen.setDashPattern(dashes);

  The dash pattern is specified in units of the pens width; e.g. a dash of length 5 in width 10 is 50 pixels long. Note that a pen with zero width is equivalent to a cosmetic pen with a width of 1 pixel.

  Each dash is also subject to cap styles so a dash of 1 with square cap set will extend 0.5 pixels out in each direction resulting in a total width of 2.

  Note that the default cap style is `Qt::SquareCap` , meaning that a square line end covers the end point and extends beyond it by half the line width.

See also:
  `setStyle()`, `dashPattern()`, `setCapStyle()`, and `setCosmetic()`.

### setJoinStyle

    public final void setJoinStyle(Qt.PenJoinStyle pcs)

  Sets the pen's join style to the given `style`. The default value is `Qt::BevelJoin` .

See also:
  `joinStyle()`, and `Join Style`.

### setMiterLimit

    public final void setMiterLimit(double limit)

  Sets the miter limit of this pen to the given `limit`.
  The miter limit describes how far a miter join can extend from the join point. This is used to reduce artifacts between line joins where the lines are close to parallel.

  This value does only have effect when the pen style is set to `Qt::MiterJoin` . The value is specified in units of the pen's width, e.g. a miter limit of 5 in width 10 is 50 pixels long. The default miter limit is 2, i.e. twice the pen width in pixels.

See also:
  `miterLimit()`, `setJoinStyle()`, and `Join Style`.

### setStyle

    public final void setStyle(Qt.PenStyle arg__1)

  Sets the pen style to the given `style`.

  See the `Qt::PenStyle` documentation for a list of the available styles. Since Qt 4.1 it is also possible to specify a custom dash pattern using the `setDashPattern()` function which implicitly converts the style of the pen to `Qt::CustomDashLine` .

See also:
  `style()`, and `Pen Style`.

### setWidth

    public final void setWidth(int width)

  Sets the pen width to the given `width` in pixels with integer precision.

  A line width of zero indicates a cosmetic pen. This means that the pen width is always drawn one pixel wide, independent of the `transformation` set on the painter.

  Setting a pen width with a negative value is not supported.

See also:
  `setWidthF()`, and `width()`.

### setWidthF

    public final void setWidthF(double width)

  Sets the pen width to the given `width` in pixels with floating point precision.

  A line width of zero indicates a cosmetic pen. This means that the pen width is always drawn one pixel wide, independent of the `transformation` on the painter.

  Setting a pen width with a negative value is not supported.

See also:
  `setWidth()`, and `widthF()`.

### style

    public final Qt.PenStyle style()

  Returns the pen style.

See also:
  `setStyle()`, and `Pen Style`.

### width

    public final int width()

  Returns the pen width with integer precision.

See also:
  `setWidth()`, and `widthF()`.

### widthF

    public final double widthF()

  Returns the pen width with floating point precision.

See also:
  `setWidthF()`, and `width()`.

### toString

    public java.lang.String toString()

  Returns a string representation of the `this QPen`.

  Overrides:
    `toString` in class `java.lang.Object`

### clone

    public QPen clone()

  This method is reimplemented for internal reasons

  Overrides:
    `clone` in class `java.lang.Object`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD